﻿using System;
using COMET2Lib;

namespace CASLII3
{
    class Program
    {
        // 使い方の簡易説明
        private static int usage()
        {
            Console.Error.WriteLine("usage: CASLII3 srcFileName [-t]");
            return 4;
        }

        static int Main(string[] args)
        {
            if (args.Length < 1 || args.Length > 2) return usage();
            var interpreter = new Interpreter();
            var assembler = new Assembler(interpreter);

            if (args.Length == 2)
            {
                if (args[1] == "-t") interpreter.traceMode = true;
                else return usage();
            }

            if (!assembler.assemble(args[0], 1)) return 2;
            if (!assembler.assemble(args[0], 2)) return 2;
            interpreter.interprete();
            return 0;
        }
    }
}
