﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Text;
using COMET2Lib;

namespace CASLII4
{
    class Program
    {
        // 使い方の簡易説明
        private static int usage()
        {
            Console.Error.WriteLine("usage: CASLII4 srcFileName\n");
            return 4;
        }

        static int Main(string[] args)
        {
            if (args.Length < 1 || args.Length > 2) return usage();
            var interpreter = new Interpreter();
            var assembler = new Assembler(interpreter);

            if (args.Length == 2) return usage();

            string outpath = Path.ChangeExtension(args[0], ".exe");

            if (!assembler.assemble(args[0], 1)) return 2;
            if (!assembler.assemble(args[0], 2)) return 2;
            if (!assembler.CreateIntermeditateSource(outpath)) return 2;
            // 作成成功した実行ファイルをキックする
            var process = new System.Diagnostics.Process();
            process.StartInfo.FileName = outpath;
            process.StartInfo.UseShellExecute = false;
            process.Start();
            process.WaitForExit();

            return 0;
        }
    }
}
